## vst3sdk 3.7.10.14+~4.13.3

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.5.0)

project(smtg_public_sdk VERSION 1.0.0)

#--sdk common----------------
add_library(sdk_common
    STATIC
        source/common/commoniids.cpp
        source/common/openurl.cpp
        source/common/openurl.h
        source/common/systemclipboard.h
        source/common/systemclipboard_linux.cpp
        source/common/systemclipboard_win32.cpp
        source/common/threadchecker.h
        source/common/threadchecker_linux.cpp
        source/common/threadchecker_win32.cpp
)
if(VST_SDK)
    target_sources(sdk_common 
        PRIVATE
		    source/common/readfile.cpp
            source/common/readfile.h
            source/vst/vstpresetfile.cpp
            source/vst/vstpresetfile.h
    )
else()
    target_sources(sdk_common 
        PRIVATE
            source/common/pvaluecontainer.cpp
            source/common/pvaluecontainer.h
            source/common/pattributes.cpp
            source/common/pattributes.h
    )
endif(VST_SDK)
if(SMTG_MAC)
    target_sources(sdk_common 
        PRIVATE
            source/common/threadchecker_mac.mm
            source/common/systemclipboard_mac.mm
    )
endif(SMTG_MAC)

# add dependencies
target_link_libraries(sdk_common 
    PUBLIC 
        base
        pluginterfaces
)
target_include_directories(sdk_common
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/..
)
smtg_target_setup_universal_binary(sdk_common)

if(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)
	get_target_property(sdk_common_SOURCES sdk_common SOURCES)
    add_library(sdk_common_ios 
        STATIC 
            ${sdk_common_SOURCES}
    )
    smtg_target_set_platform_ios(sdk_common_ios)
    set_target_properties(sdk_common_ios
        PROPERTIES
            ${SDK_IDE_LIBS_FOLDER}
    )
    target_link_libraries(sdk_common_ios 
        PUBLIC 
            base_ios
            pluginterfaces_ios
    )
	target_compile_features(sdk_common_ios PUBLIC cxx_std_17)
endif()

#--sdk plugin----------------
add_library(sdk
    STATIC 
        source/common/pluginview.cpp
        source/common/pluginview.h
        source/main/pluginfactory.cpp
        source/main/pluginfactory.h
        source/main/pluginfactory_constexpr.h
)

# Additional sources for VST3 SDK usage
if(VST_SDK)
    target_sources(sdk
        PRIVATE
            source/main/moduleinit.cpp
            source/main/moduleinit.h
            source/vst/utility/alignedalloc.h
            source/vst/utility/audiobuffers.h
            source/vst/utility/dataexchange.cpp
            source/vst/utility/dataexchange.h
            source/vst/utility/memoryibstream.h
            source/vst/utility/processcontextrequirements.h
            source/vst/utility/processdataslicer.h
            source/vst/utility/ringbuffer.h
            source/vst/utility/rttransfer.h
            source/vst/utility/sampleaccurate.h
            source/vst/utility/stringconvert.cpp
            source/vst/utility/stringconvert.h
            source/vst/utility/systemtime.h
            source/vst/utility/systemtime.cpp
            source/vst/utility/testing.cpp
            source/vst/utility/testing.h
            source/vst/utility/vst2persistence.h
            source/vst/utility/vst2persistence.cpp
            source/vst/vstaudioeffect.cpp
            source/vst/vstaudioeffect.h
            source/vst/vstbus.cpp
            source/vst/vstbus.h
            source/vst/vstbypassprocessor.h
            source/vst/vstcomponent.cpp
            source/vst/vstcomponent.h
            source/vst/vstcomponentbase.cpp
            source/vst/vstcomponentbase.h
            source/vst/vsteditcontroller.cpp
            source/vst/vsteditcontroller.h
            source/vst/vsteventshelper.h
            source/vst/vsthelpers.h
            source/vst/vstinitiids.cpp
            source/vst/vstnoteexpressiontypes.cpp
            source/vst/vstnoteexpressiontypes.h
            source/vst/vstparameters.cpp
            source/vst/vstparameters.h
            source/vst/vstrepresentation.cpp
            source/vst/vstrepresentation.h
    )
endif(VST_SDK)

target_compile_features(sdk
    PUBLIC
        cxx_std_17
)

# add dependencies
target_link_libraries(sdk 
    PUBLIC 
        sdk_common
)
target_include_directories(sdk
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/..
)
smtg_target_setup_universal_binary(sdk)
get_target_property(sdk_SOURCES sdk SOURCES)

# iOS target
if(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)
    add_library(sdk_ios 
        STATIC 
            ${sdk_SOURCES}
    )
    smtg_target_set_platform_ios(sdk_ios)
    set_target_properties(sdk_ios
        PROPERTIES
            ${SDK_IDE_LIBS_FOLDER}
    )
    target_link_libraries(sdk_ios 
        PUBLIC 
            sdk_common_ios
    )
	target_compile_features(sdk_ios PUBLIC cxx_std_17)
endif(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)

#--for hosting----------------
if(VST_SDK)
    add_library(sdk_hosting 
        STATIC
            source/vst/hosting/connectionproxy.cpp
            source/vst/hosting/connectionproxy.h
            source/vst/hosting/eventlist.cpp
            source/vst/hosting/eventlist.h
            source/vst/hosting/hostclasses.cpp
            source/vst/hosting/hostclasses.h
            source/vst/hosting/module.cpp
            source/vst/hosting/module.h
            source/vst/hosting/parameterchanges.cpp
            source/vst/hosting/parameterchanges.h
            source/vst/hosting/pluginterfacesupport.cpp
            source/vst/hosting/pluginterfacesupport.h
            source/vst/hosting/processdata.cpp
            source/vst/hosting/processdata.h
            source/vst/utility/optional.h
            source/vst/utility/stringconvert.cpp
            source/vst/utility/stringconvert.h
            source/vst/utility/uid.h
            source/vst/utility/versionparser.h
            source/vst/vstinitiids.cpp
    )
    # add dependencies
    target_link_libraries(sdk_hosting 
        PUBLIC 
            sdk_common
    )
    target_include_directories(sdk_hosting
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}/..
    )
    smtg_target_setup_universal_binary(sdk_hosting)

    # iOS target for hosting
    if(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)
	    get_target_property(sdk_hosting_SOURCES sdk_hosting SOURCES)
        add_library(sdk_hosting_ios STATIC 
            ${sdk_hosting_SOURCES}
        )
        smtg_target_set_platform_ios(sdk_hosting_ios)
        set_target_properties(sdk_hosting_ios
            PROPERTIES
                ${SDK_IDE_LIBS_FOLDER}
        )
        target_link_libraries(sdk_hosting_ios
            PUBLIC 
                sdk_common_ios
        )
		target_compile_features(sdk_hosting_ios PUBLIC cxx_std_17)
		target_include_directories(sdk_hosting_ios
			PUBLIC
				${CMAKE_CURRENT_SOURCE_DIR}/..
		)
    endif(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)
endif(VST_SDK)

=== vstgui/standalone/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(vstgui_add_executable)

##########################################################################################
set(target vstgui_standalone)

set(${target}_common_sources
    include/appinit.h
    include/doc.h
    include/fwd.h
    include/ialertbox.h
    include/iappdelegate.h
    include/iapplication.h
    include/iasync.h
    include/icommand.h
    include/icommondirectories.h
    include/imenubuilder.h
    include/interface.h
    include/ipreference.h
    include/ishareduiresources.h
    include/iuidescwindow.h
    include/ivalue.h
    include/ivaluelistener.h
    include/iwindow.h
    include/iwindowcontroller.h
    include/iwindowlistener.h
    include/helpers/appdelegate.h
    include/helpers/async.h
    include/helpers/menubuilder.h
    include/helpers/preferences.h
    include/helpers/value.h
    include/helpers/valuelistener.h
    include/helpers/windowcontroller.h
    include/helpers/windowlistener.h
    include/helpers/uidesc/modelbinding.h
    include/helpers/uidesc/customization.h
    source/application.cpp
    source/application.h
    source/genericalertbox.cpp
    source/genericalertbox.h
    source/shareduiresources.cpp
    source/shareduiresources.h
    source/uidescriptionwindowcontroller.cpp
    source/window.cpp
    source/window.h
    source/platform/iplatformwindow.h
    source/helpers/value.cpp
)

##########################################################################################
set(${target}_mac_sources
    source/platform/mac/VSTGUICommand.h
    source/platform/mac/VSTGUICommand.mm
    source/platform/mac/macasync.mm
    source/platform/mac/macasync.h
    source/platform/mac/macapplication.mm
    source/platform/mac/maccommondirectories.h
    source/platform/mac/maccommondirectories.mm
    source/platform/mac/macpreference.h
    source/platform/mac/macpreference.mm
    source/platform/mac/macutilities.h
    source/platform/mac/macwindow.h
    source/platform/mac/macwindow.mm
    source/platform/win32
    source/platform/gdk
    cmake/modules/
)

##########################################################################################
set(${target}_win32_sources
    source/platform/win32/win32application.cpp
    source/platform/win32/win32async.cpp
    source/platform/win32/win32async.h
    source/platform/win32/win32commondirectories.h
    source/platform/win32/win32commondirectories.cpp
    source/platform/win32/win32menu.cpp
    source/platform/win32/win32menu.h
    source/platform/win32/win32preference.cpp
    source/platform/win32/win32preference.h
    source/platform/win32/win32window.cpp
    source/platform/win32/win32window.h
)

set(${target}_gdk_sources
    source/platform/gdk/gdkapplication.cpp
    source/platform/gdk/gdkapplication.h
    source/platform/gdk/gdkasync.cpp
    source/platform/gdk/gdkcommondirectories.cpp
    source/platform/gdk/gdkcommondirectories.h
    source/platform/gdk/gdkpreference.cpp
    source/platform/gdk/gdkpreference.h
    source/platform/gdk/gdkrunloop.cpp
    source/platform/gdk/gdkrunloop.h
    source/platform/gdk/gdkwindow.cpp
    source/platform/gdk/gdkwindow.h
)

##########################################################################################
if(CMAKE_HOST_APPLE)
    set(${target}_sources ${${target}_common_sources} ${${target}_mac_sources})

    set_source_files_properties(${${target}_sources} PROPERTIES
        COMPILE_FLAGS "-fobjc-arc"
    )
endif()

##########################################################################################
if(MSVC)
    set(${target}_sources ${${target}_common_sources} ${${target}_win32_sources})
endif()

##########################################################################################
if(LINUX)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(SQLITE3 REQUIRED sqlite3)

    set(${target}_sources ${${target}_common_sources} ${${target}_gdk_sources})
endif()

##########################################################################################
add_library(${target} STATIC ${${target}_sources})

target_compile_definitions(${target} ${VSTGUI_COMPILE_DEFINITIONS})
vstgui_set_cxx_version(${target} 17)
vstgui_source_group_by_folder(${target})

if(VSTGUI_STANDALONE_EXAMPLES)
    add_subdirectory(examples)
endif()

if(LINUX)
    target_include_directories(${target} PRIVATE ${X11_INCLUDE_DIR})
    target_include_directories(${target} PRIVATE ${GTKMM3_INCLUDE_DIRS})
    target_include_directories(${target} PRIVATE ${FREETYPE_INCLUDE_DIRS})
    target_include_directories(${target} PRIVATE ${SQLITE3_INCLUDE_DIRS})
    target_link_libraries(${target} PRIVATE vstgui_uidescription ${LINUX_LIBRARIES} dl ${SQLITE3_LIBRARIES})
endif()

if(CMAKE_HOST_APPLE)
  target_compile_options(${target} PRIVATE -Wall -Werror)
endif()

=== vstgui/uidescription/CMakeLists.txt ===
##########################################################################################
# VSTGUI UIDescription Library
##########################################################################################
set(target vstgui_uidescription)

set(${target}_sources
    base64codec.h
    compresseduidescription.cpp
    compresseduidescription.h
    cstream.cpp
    cstream.h
    delegationcontroller.h
    doc.h
    icontentprovider.h
    icontroller.h
    iuidescription.h
    iviewcreator.h
    iviewfactory.h
    uiattributes.cpp
    uiattributes.h
    uicontentprovider.cpp
    uicontentprovider.h
    uidescription.cpp
    uidescription.h
    uidescriptionlistener.h
    uidescriptionfwd.h
    uiviewcreator.cpp
    uiviewcreator.h
    uiviewfactory.cpp
    uiviewfactory.h
    uiviewswitchcontainer.cpp
    uiviewswitchcontainer.h
    xmlparser.cpp
    xmlparser.h
    detail/locale.h
    detail/parsecolor.h
    detail/scalefactorutils.h
    detail/uidesclist.cpp
    detail/uidesclist.h
    detail/uijsonpersistence.cpp
    detail/uijsonpersistence.h
    detail/uinode.cpp
    detail/uinode.h
    detail/uiviewcreatorattributes.h
    detail/uixmlpersistence.cpp
    detail/uixmlpersistence.h
    editing/doc.h
    editing/iaction.h
    editing/igridprocessor.h
    editing/uiactions.cpp
    editing/uiactions.h
    editing/uiattributescontroller.cpp
    editing/uiattributescontroller.h
    editing/uibasedatasource.h
    editing/uibitmapscontroller.cpp
    editing/uibitmapscontroller.h
    editing/uicolor.cpp
    editing/uicolor.h
    editing/uicolorchoosercontroller.cpp
    editing/uicolorchoosercontroller.h
    editing/uicolorscontroller.cpp
    editing/uicolorscontroller.h
    editing/uicolorslider.cpp
    editing/uicolorslider.h
    editing/uicrosslines.cpp
    editing/uicrosslines.h
    editing/uidescriptioneditor.uidesc
    editing/uidialogcontroller.cpp
    editing/uidialogcontroller.h
    editing/uieditcontroller.cpp
    editing/uieditcontroller.h
    editing/uieditmenucontroller.cpp
    editing/uieditmenucontroller.h
    editing/uieditview.cpp
    editing/uieditview.h
    editing/uifocussettingscontroller.cpp
    editing/uifocussettingscontroller.h
    editing/uifontscontroller.cpp
    editing/uifontscontroller.h
    editing/uigradientscontroller.cpp
    editing/uigradientscontroller.h
    editing/uigrid.h
    editing/uigridcontroller.cpp
    editing/uigridcontroller.h
    editing/uioverlayview.cpp
    editing/uioverlayview.h
    editing/uiselection.cpp
    editing/uiselection.h
    editing/uitagscontroller.cpp
    editing/uitagscontroller.h
    editing/uitemplatecontroller.cpp
    editing/uitemplatecontroller.h
    editing/uitemplatesettingscontroller.cpp
    editing/uitemplatesettingscontroller.h
    editing/uiundomanager.cpp
    editing/uiundomanager.h
    editing/uiviewcreatecontroller.cpp
    editing/uiviewcreatecontroller.h
    viewcreator/animationsplashscreencreator.cpp
    viewcreator/animationsplashscreencreator.h
    viewcreator/animknobcreator.cpp
    viewcreator/animknobcreator.h
    viewcreator/autoanimationcreator.cpp
    viewcreator/autoanimationcreator.h
    viewcreator/checkboxcreator.cpp
    viewcreator/checkboxcreator.h
    viewcreator/controlcreator.cpp
    viewcreator/controlcreator.h
    viewcreator/gradientviewcreator.cpp
    viewcreator/gradientviewcreator.h
    viewcreator/kickbuttoncreator.cpp
    viewcreator/kickbuttoncreator.h
    viewcreator/knobcreator.cpp
    viewcreator/knobcreator.h
    viewcreator/layeredviewcontainercreator.cpp
    viewcreator/layeredviewcontainercreator.h
    viewcreator/moviebitmapcreator.cpp
    viewcreator/moviebitmapcreator.h
    viewcreator/moviebuttoncreator.cpp
    viewcreator/moviebuttoncreator.h
    viewcreator/multibitmapcontrolcreator.cpp
    viewcreator/multibitmapcontrolcreator.h
    viewcreator/multilinetextlabelcreator.cpp
    viewcreator/multilinetextlabelcreator.h
    viewcreator/onoffbuttoncreator.cpp
    viewcreator/onoffbuttoncreator.h
    viewcreator/optionmenucreator.cpp
    viewcreator/optionmenucreator.h
    viewcreator/paramdisplaycreator.cpp
    viewcreator/paramdisplaycreator.h
    viewcreator/rockerswitchcreator.cpp
    viewcreator/rockerswitchcreator.h
    viewcreator/rowcolumnviewcreator.cpp
    viewcreator/rowcolumnviewcreator.h
    viewcreator/scrollviewcreator.cpp
    viewcreator/scrollviewcreator.h
    viewcreator/searchtexteditcreator.cpp
    viewcreator/searchtexteditcreator.h
    viewcreator/segmentbuttoncreator.cpp
    viewcreator/segmentbuttoncreator.h
    viewcreator/shadowviewcontainercreator.cpp
    viewcreator/shadowviewcontainercreator.h
    viewcreator/sliderviewcreator.cpp
    viewcreator/sliderviewcreator.h
    viewcreator/splitviewcreator.cpp
    viewcreator/splitviewcreator.h
    viewcreator/stringlistcontrolcreator.cpp
    viewcreator/stringlistcontrolcreator.h
    viewcreator/switchcreators.cpp
    viewcreator/switchcreators.h
    viewcreator/textbuttoncreator.cpp
    viewcreator/textbuttoncreator.h
    viewcreator/texteditcreator.cpp
    viewcreator/texteditcreator.h
    viewcreator/textlabelcreator.cpp
    viewcreator/textlabelcreator.h
    viewcreator/uiviewswitchcontainercreator.cpp
    viewcreator/uiviewswitchcontainercreator.h
    viewcreator/viewcontainercreator.cpp
    viewcreator/viewcontainercreator.h
    viewcreator/viewcreator.cpp
    viewcreator/viewcreator.h
    viewcreator/vumetercreator.cpp
    viewcreator/vumetercreator.h
    viewcreator/xypadcreator.cpp
    viewcreator/xypadcreator.h
)

##########################################################################################
if(CMAKE_HOST_APPLE)
endif()

##########################################################################################
if(MSVC)
endif()

##########################################################################################
add_library(${target} STATIC ${${target}_sources})

add_dependencies(${target} vstgui)
target_link_libraries(${target} PRIVATE vstgui)
target_compile_definitions(${target} ${VSTGUI_COMPILE_DEFINITIONS})
vstgui_set_cxx_version(${target} 17)
vstgui_source_group_by_folder(${target})

##########################################################################################
if(LINUX)
    set (VSTGUI_GENERATED_DIR ${PROJECT_BINARY_DIR}/${PROJECT_NAME}.generated)
    
    execute_process(
        COMMAND
            ${CMAKE_CURRENT_SOURCE_DIR}/editing/createuidescdata.sh ${VSTGUI_GENERATED_DIR}
        WORKING_DIRECTORY
            ${CMAKE_CURRENT_SOURCE_DIR}/editing/
        RESULT_VARIABLE
            result
    )

    if(result EQUAL 0)
        target_compile_definitions(${target} ${VSTGUI_COMPILE_DEFINITIONS} "HAVE_EDITORUIDESC_H")
    else()
        message(FATAL_ERROR "Generating editoruidesc.h failed: ${result}")
    endif()

    target_include_directories(${target}
        PRIVATE
            ${VSTGUI_GENERATED_DIR}
    )
endif()
##########################################################################################
find_package(EXPAT)
if(EXPAT_FOUND)
    target_compile_definitions(${target} ${VSTGUI_COMPILE_DEFINITIONS} "VSTGUI_USE_SYSTEM_EXPAT")
    target_link_libraries(${target} PRIVATE ${EXPAT_LIBRARY})
	target_include_directories(${target} PRIVATE ${EXPAT_INCLUDE_DIRS})
    message(STATUS "VSTGUI will use the Expat library at ${EXPAT_LIBRARY}")
    message(STATUS "VSTGUI will use the Expat header found in ${EXPAT_INCLUDE_DIRS}")
else()
    message(STATUS "VSTGUI will use the embedded Expat package!")
endif()

if(CMAKE_HOST_APPLE)
  target_compile_options(${target} PRIVATE -Wall -Werror)
endif()

=== samples/vst-hosting/audiohost/CMakeLists.txt ===

if(SMTG_ENABLE_VST3_HOSTING_EXAMPLES)
 
    include(SMTG_FindJack)

    if(${LIBJACK_FOUND})
        set(audiohost_sources
            "${SDK_ROOT}/public.sdk/samples/vst-hosting/editorhost/source/platform/iapplication.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/connectionproxy.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/connectionproxy.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/eventlist.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/eventlist.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/hostclasses.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/hostclasses.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/module.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/module.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/parameterchanges.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/parameterchanges.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/pluginterfacesupport.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/pluginterfacesupport.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/plugprovider.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/plugprovider.h"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/processdata.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/hosting/processdata.h"
            "${SDK_ROOT}/public.sdk/source/vst/utility/optional.h"
            "${SDK_ROOT}/public.sdk/source/vst/utility/stringconvert.cpp"
            "${SDK_ROOT}/public.sdk/source/vst/utility/stringconvert.h"
            "${SDK_ROOT}/public.sdk/source/vst/utility/uid.h"
            "${SDK_ROOT}/public.sdk/source/vst/vstinitiids.cpp"
            source/audiohost.cpp
            source/audiohost.h
            source/media/audioclient.cpp
            source/media/audioclient.h
            source/media/imediaserver.h
            source/media/iparameterclient.h
            source/media/jack/jackclient.cpp
            source/media/miditovst.h
            source/platform/appinit.h
            source/usediids.cpp
        )

        if(SMTG_MAC)
            set(audiohost_sources 
                ${audiohost_sources}
                "${SDK_ROOT}/public.sdk/source/vst/hosting/module_mac.mm"
            )
             set_source_files_properties(
                "${SDK_ROOT}/public.sdk/source/vst/hosting/module_mac.mm" PROPERTIES
                COMPILE_FLAGS "-fobjc-arc"
            )
           set(audiohost_PLATFORM_LIBS "-framework CoreFoundation")
            get_filename_component(InfoPlistFile "resource/Info.plist" ABSOLUTE)
            set(APP_PROPERTIES
                MACOSX_BUNDLE TRUE
                MACOSX_BUNDLE_INFO_PLIST ${InfoPlistFile}
            )
        elseif(SMTG_LINUX)
            set(audiohost_sources
                ${audiohost_sources}
                "${SDK_ROOT}/public.sdk/source/vst/hosting/module_linux.cpp"
            )
            set(audiohost_PLATFORM_LIBS)
            set(APP_PROPERTIES)
        elseif(SMTG_WIN)
            set(audiohost_sources
                ${audiohost_sources}
                "${SDK_ROOT}/public.sdk/source/vst/hosting/module_win32.cpp"
            )
            set(audiohost_PLATFORM_LIBS)
            if(MSVC)
                set(APP_PROPERTIES
                    LINK_FLAGS
                        "/SUBSYSTEM:console"
                )
            endif(MSVC)
        endif(SMTG_MAC)

        set(target audiohost)

        add_executable(${target} ${audiohost_sources})
        set_target_properties(${target}
            PROPERTIES
                ${SDK_IDE_HOSTING_EXAMPLES_FOLDER}
        )
        target_compile_features(${target}
            PUBLIC
                cxx_std_17
        )
        target_link_libraries(${target} 
            PRIVATE
                base sdk
                ${audiohost_PLATFORM_LIBS}
                ${LIBJACK_LIBRARY}
        )
        target_include_directories(${target}
            PRIVATE
                ${LIBJACK_INCLUDE_DIR}
        )
        if (APP_PROPERTIES)
            set_target_properties(${target}
                PROPERTIES
                    ${APP_PROPERTIES}
            )
        endif(APP_PROPERTIES)
    else()
        message(STATUS "[SMTG] LIBJACK_FOUND is not set.")  
    endif(${LIBJACK_FOUND})

endif(SMTG_ENABLE_VST3_HOSTING_EXAMPLES)

=== samples/vst-hosting/inspectorapp/CMakeLists.txt ===

if(SMTG_ENABLE_VST3_HOSTING_EXAMPLES AND TARGET vstgui AND TARGET vstgui_standalone)

    ##########################################################################################
    set(target VST3Inspector)

    ##########################################################################################
    set(${target}_sources
        "source/app.cpp"
        "source/window.cpp"
        "source/window.h"
        "${SDK_ROOT}/pluginterfaces/base/coreiids.cpp"
        "${SDK_ROOT}/public.sdk/source/vst/hosting/module.h"
        "${SDK_ROOT}/public.sdk/source/vst/hosting/module.cpp"
        "${SDK_ROOT}/public.sdk/source/vst/utility/stringconvert.h"
        "${SDK_ROOT}/public.sdk/source/vst/utility/stringconvert.cpp"
        "${SDK_ROOT}/public.sdk/source/vst/moduleinfo/moduleinfoparser.cpp"
        "${SDK_ROOT}/public.sdk/source/vst/moduleinfo/moduleinfocreator.cpp"
    )

    set(${target}_resources
        "resource/window.uidesc"
    )

    ##########################################################################################
    if(SMTG_MAC)
        set(${target}_sources 
            ${${target}_sources}
            "${SDK_ROOT}/public.sdk/source/vst/hosting/module_mac.mm"
        )
        set_source_files_properties(
            "${SDK_ROOT}/public.sdk/source/vst/hosting/module_mac.mm" PROPERTIES
            COMPILE_FLAGS "-fobjc-arc"
        )
    elseif(SMTG_WIN)
        set(${target}_sources 
            ${${target}_sources}
            "${SDK_ROOT}/public.sdk/source/vst/hosting/module_win32.cpp"
        )
    elseif(SMTG_LINUX)
        set(${target}_sources 
            ${${target}_sources}
            "${SDK_ROOT}/public.sdk/source/vst/hosting/module_linux.cpp"
        )
    endif(SMTG_MAC)

    ##########################################################################################
	# 'vstgui_add_executable' links both targets 'vstgui' and 'vstgui_standalone' to 'VST3Inspector'
    vstgui_add_executable(${target} "${${target}_sources}")
    vstgui_set_target_bundle_id(${target} "com.steinberg.vstsdk.vst3inspector")

    if(NOT SMTG_MAC)
        set_target_properties(${target}
            PROPERTIES
                RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/$<$<CONFIG:Debug>:bin/Debug>$<$<CONFIG:Release>:bin/Release>$<$<CONFIG:ReleaseLTO>:bin/ReleaseLTO>/VST3Inspector
        )
    endif(NOT SMTG_MAC)

    vstgui_add_resources(${target} "${${target}_resources}")
    vstgui_set_target_infoplist(${target} "resource/Info.plist")
    #vstgui_set_cxx_version(${target} 17)

    target_include_directories(${target}
        PRIVATE
            "${SMTG_VSTGUI_SOURCE_DIR}/"
            "${SDK_ROOT}"
    )

    if(SDK_IDE_HOSTING_EXAMPLES_FOLDER)
        set_target_properties(${target}
            PROPERTIES
                ${SDK_IDE_HOSTING_EXAMPLES_FOLDER}
        )
    endif(SDK_IDE_HOSTING_EXAMPLES_FOLDER)

endif()

=== samples/vst/again/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15.0)

project(smtg-vst3-again
    VERSION ${vstsdk_VERSION}.0
    DESCRIPTION "Steinberg VST 3 AGain example"
)

if(NOT SMTG_ENABLE_VSTGUI_SUPPORT)
    return()
endif()

if (SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION)
    set(again_vst2_sources
        ${SDK_ROOT}/public.sdk/source/vst/vst2wrapper/vst2wrapper.sdk.cpp
        source/againentry_vst2.cpp
    )
endif(SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION)

set(again_sources
    source/again.cpp
    source/again.h
    source/againcids.h
    source/againcontroller.cpp
    source/againcontroller.h
    source/againentry.cpp
    source/againparamids.h
    source/againprocess.h
    source/againsidechain.cpp
    source/againsidechain.h
    source/againuimessagecontroller.h
    source/version.h
    resource/again.uidesc
)

set(again_simple_sources
    ${SDK_ROOT}/public.sdk/source/vst/vstsinglecomponenteffect.cpp
    ${SDK_ROOT}/public.sdk/source/vst/vstsinglecomponenteffect.h
    source/againparamids.h
    source/againsimple.cpp
    source/againsimple.h
    source/version.h
)

# VST2 is only defined for macOS and Windows
if(SMTG_MAC OR SMTG_WIN)
    if (SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION)
        set(again_sources ${again_sources} ${again_vst2_sources})
    else()
        set(again_sources ${again_sources})
    endif(SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION)
endif(SMTG_MAC OR SMTG_WIN)

set(target again)

smtg_add_vst3plugin(${target} ${again_sources})
smtg_target_configure_version_file(${target})

#smtg_add_vst3plugin(${target} PACKAGE_NAME "A Gain" SOURCES_LIST ${again_sources})
set_target_properties(${target} 
    PROPERTIES
        ${SDK_IDE_PLUGIN_EXAMPLES_FOLDER}
)

target_compile_features(${target}
    PUBLIC
        cxx_std_17
)

target_link_libraries(${target}
    PRIVATE
        sdk
        vstgui_support
)
smtg_target_add_plugin_resources(${target}
    RESOURCES
        resource/again.uidesc
        resource/background.png
        resource/slider_background.png
        resource/slider_handle.png
        resource/slider_handle_2.0x.png
        resource/vu_on.png
        resource/vu_off.png
)

smtg_target_add_plugin_snapshots (${target}
    RESOURCES
        resource/84E8DE5F92554F5396FAE4133C935A18_snapshot.png
        resource/84E8DE5F92554F5396FAE4133C935A18_snapshot_2.0x.png
        resource/41347FD6FED64094AFBB12B7DBA1D441_snapshot.png
        resource/41347FD6FED64094AFBB12B7DBA1D441_snapshot_2.0x.png
)

if(SMTG_MAC)
    smtg_target_set_bundle(${target}
        BUNDLE_IDENTIFIER "com.steinberg.vst3.${target}"
        COMPANY_NAME "Steinberg Media Technologies"
    )
elseif(SMTG_WIN)
    target_sources(${target}
        PRIVATE
            resource/again.rc
    )
endif(SMTG_MAC)

# Add an AUv2 target
if (SMTG_MAC AND XCODE AND SMTG_COREAUDIO_SDK_PATH)
	include(SMTG_AddVST3AuV2)
	smtg_target_add_auv2(again-au
		BUNDLE_NAME again
		BUNDLE_IDENTIFIER com.steinberg.vst3plugin.again.audiounit
		INFO_PLIST_TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/resource/au-info.plist
		VST3_PLUGIN_TARGET again)
endif(SMTG_MAC AND XCODE AND SMTG_COREAUDIO_SDK_PATH)

if(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)
    set(target again_ios)
    smtg_add_ios_vst3plugin(${target} "${SMTG_CODE_SIGN_IDENTITY_IOS}" "${target}" "${again_sources}")
    smtg_target_configure_version_file(${target})
    set_target_properties(${target}
        PROPERTIES
            ${SDK_IDE_PLUGIN_EXAMPLES_FOLDER}
    )
    target_include_directories(${target}
        PUBLIC
            ${SMTG_VSTGUI_SOURCE_DIR}
    )
    target_link_libraries(${target} 
        PRIVATE
            base_ios
            sdk_ios
            "-framework UIKit"
            "-framework CoreGraphics" 
            "-framework QuartzCore" 
            "-framework CoreText" 
            "-framework Accelerate" 
            "-framework ImageIO" 
            "-framework MobileCoreServices" 
    )

    smtg_target_add_plugin_resources(${target}
        RESOURCES
            resource/again.uidesc
            resource/background.png
            resource/slider_background.png
            resource/slider_handle.png
            resource/slider_handle_2.0x.png
            resource/vu_on.png
            resource/vu_off.png
    )

    smtg_target_set_bundle(${target}
        BUNDLE_IDENTIFIER "com.steinberg.vst3.again"
        COMPANY_NAME "Steinberg Media Technologies"
    )
    target_sources(${target} 
        PRIVATE 
            ${SMTG_VSTGUI_SOURCE_DIR}/vstgui/vstgui_uidescription.cpp
            ${SMTG_VSTGUI_SOURCE_DIR}/vstgui/vstgui_ios.mm
            ${SMTG_VSTGUI_SOURCE_DIR}/vstgui/plugin-bindings/vst3editor.cpp
            ${SDK_ROOT}/public.sdk/source/vst/vstguieditor.cpp
    )
	target_compile_features(${target} PUBLIC cxx_std_17)
endif(SMTG_MAC AND XCODE AND SMTG_ENABLE_IOS_TARGETS)

set(targetsimple againsimple)
smtg_add_vst3plugin(${targetsimple} ${again_simple_sources})
smtg_target_configure_version_file(${targetsimple})
set_target_properties(${targetsimple}
    PROPERTIES
        ${SDK_IDE_PLUGIN_EXAMPLES_FOLDER})
target_link_libraries(${targetsimple}
    PUBLIC
        sdk
        vstgui_support
)

smtg_target_add_plugin_resources(${targetsimple}
    RESOURCES
        resource/again.uidesc
        resource/background.png
        resource/slider_background.png
        resource/slider_handle.png
        resource/slider_handle_2.0x.png
        resource/vu_on.png
        resource/vu_off.png
)

target_compile_features(${targetsimple}
    PUBLIC
        cxx_std_17
)

if(SMTG_MAC)
    smtg_target_set_bundle(${targetsimple}
        BUNDLE_IDENTIFIER "com.steinberg.vst3.again-simple"
        COMPANY_NAME "Steinberg Media Technologies"
    )
elseif(SMTG_WIN)
    target_sources(${targetsimple}
        PRIVATE
            resource/again.rc
    )
endif(SMTG_MAC)

# do not build AGain VST 2 by default
option(SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION "Legacy: Create the VST2 version of the Sample Plug-in AGain, be sure that you have copied the VST2 interfaces into the folder VST_SDK/vst3sdk/pluginterfaces/vst2.x" OFF)
if(SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION)
    message(STATUS "[SMTG] SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION is set. A VST 2 version of the plug-in will be created (just rename the generated file from .vst3 to .dll (win) or .vst (mac)).")
    if(XCODE)
        # fix missing VSTPluginMain symbol when also building VST 2 version
        set_target_properties(${target}
            PROPERTIES
                XCODE_ATTRIBUTE_EXPORTED_SYMBOLS_FILE ""
        )
    endif(XCODE)
    if(SMTG_WIN)
        if(NOT MINGW)
            add_definitions(-D_CRT_SECURE_NO_WARNINGS)
        endif(NOT MINGW)
    endif(SMTG_WIN)
endif(SMTG_CREATE_VST2_AGAIN_SAMPLE_VERSION)

=== samples/vst/again_aax/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15.0)

project(smtg-vst3-again
    VERSION ${vstsdk_VERSION}.0
    DESCRIPTION "Steinberg VST 3 AGain AAX example"
)

if(NOT SMTG_AAX_SDK_PATH OR NOT SMTG_ENABLE_VSTGUI_SUPPORT)
    return()
endif()

include(SMTG_AddAAXLibrary)

set(again_sources
    source/againaax.cpp
    ../again/source/again.cpp
    ../again/source/again.h
    ../again/source/againcids.h
    ../again/source/againcontroller.cpp
    ../again/source/againcontroller.h
    ../again/source/againentry.cpp
    ../again/source/againparamids.h
    ../again/source/againprocess.h
    ../again/source/againsidechain.cpp
    ../again/source/againsidechain.h
    ../again/source/againuimessagecontroller.h
    ../again/source/version.h
    ../again/resource/again.uidesc
)

set(target again_aax)
smtg_add_aaxplugin(${target} ${again_sources})
smtg_target_configure_version_file(${target})
set_target_properties(${target}
    PROPERTIES
        ${SDK_IDE_PLUGIN_EXAMPLES_FOLDER}
)
target_include_directories(${target}
    PUBLIC
        ${SDK_ROOT}/public.sdk/samples/vst/again/source
)

target_compile_features(${target}
    PUBLIC
        cxx_std_17
)

target_link_libraries(${target}
    PRIVATE
        sdk
        vstgui_support
        aaxwrapper
)
smtg_target_add_plugin_resources(${target}
    RESOURCES
        ../again/resource/again.uidesc
        ../again/resource/background.png
        ../again/resource/slider_background.png
        ../again/resource/slider_handle.png
        ../again/resource/slider_handle_2.0x.png
        ../again/resource/vu_on.png
        ../again/resource/vu_off.png
)

if(SMTG_MAC)
    smtg_target_set_bundle(${target}
        BUNDLE_IDENTIFIER "com.steinberg.vst3.${target}"
        INFOPLIST "${CMAKE_CURRENT_LIST_DIR}/../again/mac/Info.plist" PREPROCESS
    )
elseif(SMTG_WIN)
    target_sources(${target} 
        PRIVATE 
            ../again/resource/again.rc
    )
    # remove warnings from VST2
    if(NOT MINGW)
        add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    endif(NOT MINGW)
endif(SMTG_MAC)

=== samples/vst/again_auv3/CMakeLists.txt ===
include(SMTG_AddVST3AuV3)

if(SMTG_MAC AND SMTG_ENABLE_VSTGUI_SUPPORT)
    if(XCODE)
        set(again_mac_app_sources
            "macOS/Sources/ViewController.m"
            "macOS/Sources/ViewController.h"
            "macOS/Sources/AppDelegate.m"
            "macOS/Sources/AppDelegate.h"
            "audiounitconfig.h"
        )

        set(again_ios_app_sources
            "iOS/Sources/ViewController.m"
            "iOS/Sources/ViewController.h"
            "iOS/Sources/AppDelegate.m"
            "iOS/Sources/AppDelegate.h"
            "iOS/Sources/main.mm"
            "audiounitconfig.h"
        )

        set(again_mac_app_ui_resources
            "macOS/Resources/Base.lproj/Main.storyboard"
            "macOS/Resources/again.icns"
            "Shared/drumLoop.wav"
        )

        set(again_ios_app_ui_resources
            "iOS/Resources/Base.lproj/LaunchScreen.storyboard"
            "iOS/Resources/Base.lproj/Main.storyboard"
            "iOS/Resources/Assets.xcassets"
            "Shared/drumLoop.wav"
        )

        #--------------------------------------------------------------------------------------------------------
        # macOS target
        #--------------------------------------------------------------------------------------------------------
        smtg_add_auv3_app(again_auv3_macos "macOS" "AGain AUV3 macOS" "com.steinberg.sdk.auv3.againmac" audiounitconfig.h "macOS/again.entitlements" "${again_mac_app_sources}" "${again_mac_app_ui_resources}" "macOS/Resources/Info.plist" "Shared/Info.plist" again)

        #--------------------------------------------------------------------------------------------------------
        # iOS target
        #--------------------------------------------------------------------------------------------------------
        if(SMTG_ENABLE_IOS_TARGETS)
            smtg_add_auv3_app(again_auv3_ios "iOS" "AGain AUV3 iOS" "com.steinberg.sdk.auv3.againios" "audiounitconfig.h" "iOS/again.entitlements" "${again_ios_app_sources}" "${again_ios_app_ui_resources}" "iOS/Resources/Info.plist" "Shared/Info.plist" again_ios)
        endif(SMTG_ENABLE_IOS_TARGETS)
    endif(XCODE)
endif(SMTG_MAC AND SMTG_ENABLE_VSTGUI_SUPPORT)

=== samples/vst/again_sampleaccurate/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15.0)

project(smtg-vst3-again-sampleaccurate
    VERSION ${vstsdk_VERSION}.0
    DESCRIPTION "Steinberg VST 3 AGain example"
)

smtg_add_vst3plugin(again-sampleaccurate 
    source/agsa_controller.cpp
    source/agsa_factory.cpp
    source/agsa_processor.cpp
    source/agsa.h
    source/tutorial.cpp
    source/tutorial.h
    source/version.h
    ${SDK_ROOT}/public.sdk/source/vst/utility/test/sampleaccuratetest.cpp
    ${SDK_ROOT}/public.sdk/source/vst/utility/test/rttransfertest.cpp
)

target_link_libraries(again-sampleaccurate
    PRIVATE
        sdk_hosting
)

smtg_target_setup_as_vst3_example(again-sampleaccurate)

=== samples/vst/channelcontext/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15.0)

project(smtg-vst3-channelcontext
    VERSION ${vstsdk_VERSION}.0
    DESCRIPTION "Steinberg VST 3 Channel Context example"
)

smtg_add_vst3plugin(channelcontext     
    source/plug.cpp
    source/plug.h
    source/plugcids.h
    source/plugcontroller.cpp
    source/plugcontroller.h
    source/plugentry.cpp
    source/plugparamids.h
    source/version.h
)

smtg_target_setup_as_vst3_example(channelcontext)

=== samples/vst/hostchecker/CMakeLists.txt ===

if(NOT SMTG_ENABLE_VSTGUI_SUPPORT)
    return()
endif()

cmake_minimum_required(VERSION 3.15.0)

project(smtg-vst3-hostchecker
    VERSION ${vstsdk_VERSION}.0
    DESCRIPTION "Steinberg VST 3 Host Checker example"
)

smtg_add_vst3plugin(hostchecker     
    resource/hostchecker.uidesc
    source/cids.h
    source/editorsizecontroller.cpp
    source/editorsizecontroller.h
    source/eventlistcheck.cpp
    source/eventlistcheck.h
    source/eventlogdatabrowsersource.cpp
    source/eventlogdatabrowsersource.h
    source/eventlogger.cpp
    source/eventlogger.h
    source/factory.cpp
    source/hostcheck.cpp
    source/hostcheck.h
    source/hostcheckercontroller.cpp
    source/hostcheckercontroller.h
    source/hostcheckerprocessor.cpp
    source/hostcheckerprocessor.h
    source/logevents.h
    source/parameterchangescheck.cpp
    source/parameterchangescheck.h
    source/processcontextcheck.cpp
    source/processcontextcheck.h
    source/processsetupcheck.cpp
    source/processsetupcheck.h
    source/version.h
)

target_link_libraries(hostchecker
    PRIVATE
        vstgui_support
)

smtg_target_add_plugin_resources(hostchecker
    RESOURCES
        resource/hostchecker.uidesc
        resource/bypass.png
        resource/knob.png
)

smtg_target_setup_as_vst3_example(hostchecker)

=== samples/vst/hostchecker_aax/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15.0)

if(NOT SMTG_AAX_SDK_PATH OR NOT SMTG_ENABLE_VSTGUI_SUPPORT)
    return()
endif()

project(smtg-vst3-hostchecker_aax
    VERSION ${vstsdk_VERSION}.0
    DESCRIPTION "Steinberg VST 3 hostchecker AAX example"
)

include(SMTG_AddAAXLibrary)

smtg_add_aaxplugin(hostchecker_aax
    ../hostchecker/resource/hostchecker.uidesc
    ../hostchecker/source/cids.h
    ../hostchecker/source/editorsizecontroller.cpp
    ../hostchecker/source/editorsizecontroller.h
    ../hostchecker/source/eventlistcheck.cpp
    ../hostchecker/source/eventlistcheck.h
    ../hostchecker/source/eventlogdatabrowsersource.cpp
    ../hostchecker/source/eventlogdatabrowsersource.h
    ../hostchecker/source/eventlogger.cpp
    ../hostchecker/source/eventlogger.h
    ../hostchecker/source/factory.cpp
    ../hostchecker/source/hostcheck.cpp
    ../hostchecker/source/hostcheck.h
    ../hostchecker/source/hostcheckercontroller.cpp
    ../hostchecker/source/hostcheckercontroller.h
    ../hostchecker/source/hostcheckerprocessor.cpp
    ../hostchecker/source/hostcheckerprocessor.h
    ../hostchecker/source/logevents.h
    ../hostchecker/source/parameterchangescheck.cpp
    ../hostchecker/source/parameterchangescheck.h
    ../hostchecker/source/processcontextcheck.cpp
    ../hostchecker/source/processcontextcheck.h
    ../hostchecker/source/processsetupcheck.cpp
    ../hostchecker/source/processsetupcheck.h
    ../hostchecker/source/version.h
    source/hostchecker_aax.cpp
)

target_include_directories(hostchecker_aax
    PUBLIC 
        ${SDK_ROOT}/public.sdk/samples/vst/hostchecker/source
)

target_link_libraries(hostchecker_aax
    PRIVATE
        vstgui_support
        aaxwrapper
)

smtg_target_add_plugin_resources(hostchecker_aax
    RESOURCES
        ../hostchecker/resource/hostchecker.uidesc
        ../hostchecker/resource/bypass.png
        ../hostchecker/resource/knob.png
)

smtg_target_setup_as_vst3_example(hostchecker_aax)

=== debian/changelog ===
vst3sdk (3.7.10.14+~4.13.3-4) unstable; urgency=medium

  * Install interfaces to /usr/include/vst3sdk.
  * Build with -malign-double on i386, m68k and sh4 (Closes: #1095137)

 -- Andrius Merkys <merkys@debian.org>  Tue, 25 Feb 2025 09:16:44 -0500

vst3sdk (3.7.10.14+~4.13.3-3) unstable; urgency=medium

  * Install all headers (Closes: #1094382)

 -- Andrius Merkys <merkys@debian.org>  Wed, 29 Jan 2025 03:39:58 -0500

vst3sdk (3.7.10.14+~4.13.3-2) unstable; urgency=medium

  * Backport upstream patch to fix FTBFS (Closes: #1085063)

 -- Andrius Merkys <merkys@debian.org>  Mon, 14 Oct 2024 02:22:04 -0400

vst3sdk (3.7.10.14+~4.13.3-1) unstable; urgency=medium

  * Initial release (Closes: #943315)

 -- Andrius Merkys <merkys@debian.org>  Fri, 03 May 2024 03:03:06 -0400

=== debian/control ===
Source: vst3sdk
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libcairo2-dev,
 libfreetype-dev,
 libglib2.0-dev,
 libgtkmm-3.0-dev,
 libjack-dev,
 libpango1.0-dev,
 libsqlite3-dev,
 libx11-dev,
 libxcb-cursor-dev,
 libxcb-keysyms1-dev,
 libxcb-util-dev,
 libxcb-xkb-dev,
 libxkbcommon-dev,
 libxkbcommon-x11-dev,
 pkgconf,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/vst3sdk.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/vst3sdk

Package: libvst3sdk-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: VST SDK development files
 Virtual Studio Technology (VST) is an audio plug-in software interface that
 facilitates the integration of software synthesizers and effects in digital
 audio workstations (DAW).
 .
 This package contains VST SDK development files.

Package: vst3sdk-plugins
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: VST SDK plug-ins
 Virtual Studio Technology (VST) is an audio plug-in software interface that
 facilitates the integration of software synthesizers and effects in digital
 audio workstations (DAW).
 .
 This package contains VST plugins from VST SDK.

=== debian/rules ===
#!/usr/bin/make -f

CONFIGURE_OPTIONS = -DCMAKE_BUILD_TYPE=Debug

ifneq (,$(filter $(DEB_HOST_ARCH), i386 m68k sh4))
    CONFIGURE_OPTIONS += -DCMAKE_CXX_FLAGS=-malign-double
endif

%:
	dh $@

override_dh_auto_configure:
	ln -s public-sdk public.sdk
	dh_auto_configure -- $(CONFIGURE_OPTIONS)

execute_after_dh_install:
	find base -name '*.h' | while read H; do dh_install $$H usr/include/vst3sdk/$$(dirname $$H); done
	find public-sdk -name '*.h' | while read H; do dh_install $$H usr/include/vst3sdk/$$(dirname $$H | sed 's/^public-sdk/public.sdk/'); done
	find vstgui4 -name '*.h' | grep -vF /tests/ | while read H; do dh_install $$H usr/include/vst3sdk/$$(dirname $$H | sed 's/^vstgui4\///'); done

=== debian/watch ===
version=4
opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%, uversionmangle=s/_build_/\./" \
https://github.com/steinbergmedia/vst3sdk/tags \
    (?:.*?/)?v([0-9\.]+_build_\d+)@ARCHIVE_EXT@ group

opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-base-$1$2%, uversionmangle=s/_build_/\./, component=base" \
https://github.com/steinbergmedia/vst3_base/tags \
    (?:.*?/)?v([0-9\.]+_build_\d+)@ARCHIVE_EXT@

opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-cmake-$1$2%, uversionmangle=s/_build_/\./, component=cmake" \
https://github.com/steinbergmedia/vst3_cmake/tags \
    (?:.*?/)?v([0-9\.]+_build_\d+)@ARCHIVE_EXT@

## doc/ contains a lot of files diagnosed as source-is-missing by lintian
# opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-doc-$1$2%, component=doc" \
# https://github.com/steinbergmedia/vst3_doc/tags \
#     (?:.*?/)?v?@ANY_VERSION@_build_\d+@ARCHIVE_EXT@ same

opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-pluginterfaces-$1$2%, uversionmangle=s/_build_/\./, component=pluginterfaces" \
https://github.com/steinbergmedia/vst3_pluginterfaces/tags \
    (?:.*?/)?v([0-9\.]+_build_\d+)@ARCHIVE_EXT@

opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-public.sdk-$1$2%, uversionmangle=s/_build_/\./, component=public-sdk" \
https://github.com/steinbergmedia/vst3_public_sdk/tags \
    (?:.*?/)?v([0-9\.]+_build_\d+)@ARCHIVE_EXT@

# opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-tutorials-$1$2%, component=tutorials" \
# https://github.com/steinbergmedia/vst3_tutorials/tags \
#     (?:.*?/)?v?@ANY_VERSION@_build_\d+@ARCHIVE_EXT@ same

opts="filenamemangle=s%v@ANY_VERSION@_build_\d+(@ARCHIVE_EXT@)%@PACKAGE@-vstgui4-$1$2%, component=vstgui4, uversionmangle=s/_/\./g" \
https://github.com/steinbergmedia/vstgui/tags \
    (?:.*?/)?vstgui(4_\d+_\d+)@ARCHIVE_EXT@ group
